/*
 * getcpw.c - stuff for getting the decryption pw.  bogarted from gotodir.c
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include "backend.h"
#include "main.h"


static GtkWidget *cpw_win;
char	pw[256];
int	pw_entered;
int	getcpw_not_by_callback;

static void bad_pw(void)
{
  	error_dialog("xzgv error","Can not decrypt with current password!");
}

static void cpw_ok_callback(GtkWidget *button,GtkWidget *entry)
{
	char *ptr=gtk_entry_get_text(GTK_ENTRY(entry));

	if(!ptr || *ptr==0 ) {
  		gtk_widget_destroy(cpw_win);
  		return;
	}	
	strcpy(pw,ptr);
	pw_entered=0xf00d;	
	gtk_widget_destroy(cpw_win);
	if ( getcpw_not_by_callback == 0xf00d ) {
		getcpw_not_by_callback=0;
		gtk_main_quit();
	}	
}


static void cpw_cancel_callback(GtkWidget *button,GtkWidget *cdialog)
{
	gtk_widget_destroy(cpw_win);
	if ( getcpw_not_by_callback == 0xf00d ) {
		getcpw_not_by_callback=0;
		gtk_main_quit();
	}	
}


void getcpw(void)
{
GtkWidget *vbox;
GtkWidget *action_tbl,*ok_button,*cancel_button;
GtkWidget *table;
GtkWidget *label,*entry;
static char buf[256];
int tbl_row;

cpw_win=gtk_dialog_new();

gtk_window_set_title(GTK_WINDOW(cpw_win),"Specify Decryption Password");
gtk_window_set_policy(GTK_WINDOW(cpw_win),FALSE,TRUE,FALSE);
gtk_window_set_position(GTK_WINDOW(cpw_win),GTK_WIN_POS_CENTER);
gtk_window_set_modal(GTK_WINDOW(cpw_win),TRUE);

vbox=gtk_vbox_new(FALSE,10);
gtk_box_pack_start(GTK_BOX(GTK_DIALOG(cpw_win)->vbox), vbox,TRUE,TRUE,0);
gtk_widget_show(vbox);

gtk_container_set_border_width(GTK_CONTAINER(vbox),5);
gtk_container_set_border_width( GTK_CONTAINER(GTK_DIALOG(cpw_win)->action_area),5);

/* add ok/cancel buttons */
action_tbl=gtk_table_new(1,5,TRUE);
gtk_box_pack_start(GTK_BOX(GTK_DIALOG(cpw_win)->action_area), action_tbl,TRUE,TRUE,0);
gtk_widget_show(action_tbl);

ok_button=gtk_button_new_with_label("Ok");
gtk_table_attach_defaults(GTK_TABLE(action_tbl),ok_button, 1,2, 0,1);
gtk_widget_show(ok_button);

cancel_button=gtk_button_new_with_label("Cancel");
gtk_table_attach_defaults(GTK_TABLE(action_tbl),cancel_button, 3,4, 0,1);
gtk_signal_connect_object(GTK_OBJECT(cancel_button),"clicked",
                          GTK_SIGNAL_FUNC(cpw_cancel_callback),GTK_OBJECT(cpw_win));
gtk_widget_show(cancel_button);

table=gtk_table_new(2,3,TRUE);
gtk_box_pack_start(GTK_BOX(vbox),table,TRUE,TRUE,0);
gtk_table_set_col_spacings(GTK_TABLE(table),20);
gtk_table_set_row_spacings(GTK_TABLE(table),8);
gtk_container_set_border_width(GTK_CONTAINER(table),8);
gtk_widget_show(table);

#define PW_TBL_LEFT(table,row,name) \
  label=gtk_label_new(name);				\
  gtk_misc_set_alignment(GTK_MISC(label),1.,0.5);	\
  gtk_table_attach_defaults(GTK_TABLE(table),label, 0,1, (row),(row)+1); \
  gtk_widget_show(label)

#define PW_TBL_RIGHT(table,row,name) \
  label=gtk_label_new(name);				\
  gtk_misc_set_alignment(GTK_MISC(label),0.,0.5);	\
  gtk_table_attach_defaults(GTK_TABLE(table),label, 1,3, (row),(row)+1); \
  gtk_widget_show(label)

tbl_row=0;

PW_TBL_LEFT(table,tbl_row,"Decryption Password:");

entry=gtk_entry_new_with_max_length(sizeof(buf)-1);
gtk_table_attach_defaults(GTK_TABLE(table),entry, 1,3, tbl_row,tbl_row+1);
gtk_widget_grab_focus(entry);
gtk_widget_show(entry);
gtk_signal_connect(GTK_OBJECT(entry),"activate",
                   GTK_SIGNAL_FUNC(cpw_ok_callback),GTK_OBJECT(entry));

/* finally connect up the ok button */
gtk_signal_connect(GTK_OBJECT(ok_button),"clicked",
                   GTK_SIGNAL_FUNC(cpw_ok_callback),GTK_OBJECT(entry));

/* esc = cancel */
gtk_widget_add_accelerator(cancel_button,"clicked",
                           gtk_accel_group_get_default(),
                           GDK_Escape,0,0);

gtk_widget_add_accelerator(ok_button,"clicked",
                           gtk_accel_group_get_default(),
                           GDK_Return,0,0);

gtk_widget_show(cpw_win);
}
