/*
 * getssd.c - stuff for getting the slide show delay.
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include "backend.h"
#include "main.h"


GtkWidget *ssd_win;
int	ss_delay_hold;


static void ssd_changed_cb(GtkWidget *pb, gpointer data) {
        return;
}

        
static void ss_delay_cb( GtkWidget *widget, GtkWidget *spin ) {
        ss_delay_hold = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spin));
}


static void ssd_apply_cb( GtkWidget *widget, void *data ) {
	ss_delay=ss_delay_hold;
	gtk_widget_destroy(ssd_win);
}


static void ssd_cancel_cb(GtkWidget *wid, gpointer data) {
        gtk_widget_destroy(ssd_win);
}

void getssd(void)
{
	GtkWidget *vbox, *panel, *hbox, *hsep;
	GtkWidget *delay_label,*delay_c, *apply, *cancel;
	GtkObject *delay_a;

	ss_delay_hold=ss_delay;
	ssd_win=gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_window_set_transient_for(GTK_WINDOW(ssd_win), GTK_WINDOW(mainwin));
        gtk_window_set_title(GTK_WINDOW(ssd_win), "Specify Slide Show Delay");
        gtk_widget_realize(ssd_win);	
        gtk_window_set_policy(GTK_WINDOW(ssd_win),TRUE,TRUE,TRUE);
	
	vbox = gtk_vbox_new(FALSE, 2);
        panel = gtk_hbox_new(FALSE, 5);
        gtk_container_set_border_width(GTK_CONTAINER(vbox), 10);
        delay_label = gtk_label_new( "Slide Show delay in seconds" );
        delay_a = gtk_adjustment_new( ss_delay_hold, 1, 60, 1, 5, 5 );
        delay_c = gtk_spin_button_new( GTK_ADJUSTMENT(delay_a), 1, 0 );
        gtk_box_pack_start( GTK_BOX(panel), delay_label, FALSE, FALSE, 0 );
        gtk_box_pack_start( GTK_BOX(panel), delay_c, FALSE, FALSE, 0 );
        gtk_widget_show(delay_label);
        gtk_widget_show(delay_c);
        gtk_box_pack_start(GTK_BOX(vbox), panel, FALSE, FALSE, 5);
        gtk_widget_show(panel);
	gtk_signal_connect_object(GTK_OBJECT(delay_c), "changed",
                           GTK_SIGNAL_FUNC(ssd_changed_cb),GTK_OBJECT(ssd_win));
        gtk_signal_connect( GTK_OBJECT(delay_a),"value_changed",
                                GTK_SIGNAL_FUNC(ss_delay_cb), delay_c );
        gtk_signal_connect( GTK_OBJECT(delay_c),"changed",
                                GTK_SIGNAL_FUNC(ss_delay_cb), delay_c );
        gtk_spin_button_set_update_policy( GTK_SPIN_BUTTON(delay_c),
                                                        GTK_UPDATE_ALWAYS );
	hsep=gtk_hseparator_new();
        gtk_box_pack_start(GTK_BOX(vbox),hsep,FALSE,FALSE,6);
        gtk_widget_show(hsep);
        hbox= gtk_hbox_new(FALSE, 5);
        apply = gtk_button_new_with_label("Apply");
        gtk_signal_connect(GTK_OBJECT(apply), "clicked",
                                        GTK_SIGNAL_FUNC(ssd_apply_cb), NULL);
        gtk_box_pack_start(GTK_BOX(hbox), apply, TRUE, TRUE, 5);
        cancel = gtk_button_new_with_label("Cancel");
        gtk_signal_connect(GTK_OBJECT(cancel), "clicked",
                                        GTK_SIGNAL_FUNC(ssd_cancel_cb), NULL);
        gtk_box_pack_start(GTK_BOX(hbox), cancel, TRUE, TRUE, 5);
        gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
        gtk_widget_show(hbox);
        gtk_container_add(GTK_CONTAINER(ssd_win), vbox);
        gtk_widget_show(apply);
        gtk_widget_show(cancel);
        gtk_widget_show(vbox);
        gtk_widget_show(ssd_win);
}


